/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef WebKitDOMHTMLElement_h
#define WebKitDOMHTMLElement_h

#include "webkit/webkitdomdefines.h"
#include <glib-object.h>
#include <webkit/webkitdefines.h>
#include "webkit/WebKitDOMElement.h"


G_BEGIN_DECLS
#define WEBKIT_TYPE_DOM_HTML_ELEMENT            (webkit_dom_html_element_get_type())
#define WEBKIT_DOM_HTML_ELEMENT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_TYPE_DOM_HTML_ELEMENT, WebKitDOMHTMLElement))
#define WEBKIT_DOM_HTML_ELEMENT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_TYPE_DOM_HTML_ELEMENT, WebKitDOMHTMLElementClass)
#define WEBKIT_DOM_IS_HTML_ELEMENT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_TYPE_DOM_HTML_ELEMENT))
#define WEBKIT_DOM_IS_HTML_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_TYPE_DOM_HTML_ELEMENT))
#define WEBKIT_DOM_HTML_ELEMENT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_TYPE_DOM_HTML_ELEMENT, WebKitDOMHTMLElementClass))

struct _WebKitDOMHTMLElement {
    WebKitDOMElement parent_instance;
};

struct _WebKitDOMHTMLElementClass {
    WebKitDOMElementClass parent_class;
};

WEBKIT_API GType
webkit_dom_html_element_get_type (void);

WEBKIT_API WebKitDOMElement*
webkit_dom_html_element_insert_adjacent_element(WebKitDOMHTMLElement* self, const gchar* where, WebKitDOMElement* element, GError **error);

WEBKIT_API void
webkit_dom_html_element_insert_adjacent_html(WebKitDOMHTMLElement* self, const gchar* where, const gchar* html, GError **error);

WEBKIT_API void
webkit_dom_html_element_insert_adjacent_text(WebKitDOMHTMLElement* self, const gchar* where, const gchar* text, GError **error);

WEBKIT_API gchar*
webkit_dom_html_element_get_id(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_id(WebKitDOMHTMLElement* self, const gchar* value);

WEBKIT_API gchar*
webkit_dom_html_element_get_title(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_title(WebKitDOMHTMLElement* self, const gchar* value);

WEBKIT_API gchar*
webkit_dom_html_element_get_lang(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_lang(WebKitDOMHTMLElement* self, const gchar* value);

WEBKIT_API gchar*
webkit_dom_html_element_get_dir(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_dir(WebKitDOMHTMLElement* self, const gchar* value);

WEBKIT_API gchar*
webkit_dom_html_element_get_class_name(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_class_name(WebKitDOMHTMLElement* self, const gchar* value);

WEBKIT_API WebKitDOMDOMTokenList*
webkit_dom_html_element_get_class_list(WebKitDOMHTMLElement* self);

WEBKIT_API glong
webkit_dom_html_element_get_tab_index(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_tab_index(WebKitDOMHTMLElement* self, glong value);

WEBKIT_API gboolean
webkit_dom_html_element_get_draggable(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_draggable(WebKitDOMHTMLElement* self, gboolean value);

WEBKIT_API gboolean
webkit_dom_html_element_get_hidden(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_hidden(WebKitDOMHTMLElement* self, gboolean value);

WEBKIT_API gchar*
webkit_dom_html_element_get_inner_html(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_inner_html(WebKitDOMHTMLElement* self, const gchar* value, GError **error);

WEBKIT_API gchar*
webkit_dom_html_element_get_inner_text(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_inner_text(WebKitDOMHTMLElement* self, const gchar* value, GError **error);

WEBKIT_API gchar*
webkit_dom_html_element_get_outer_html(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_outer_html(WebKitDOMHTMLElement* self, const gchar* value, GError **error);

WEBKIT_API gchar*
webkit_dom_html_element_get_outer_text(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_outer_text(WebKitDOMHTMLElement* self, const gchar* value, GError **error);

WEBKIT_API WebKitDOMHTMLCollection*
webkit_dom_html_element_get_children(WebKitDOMHTMLElement* self);

WEBKIT_API gchar*
webkit_dom_html_element_get_content_editable(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_content_editable(WebKitDOMHTMLElement* self, const gchar* value);

WEBKIT_API gboolean
webkit_dom_html_element_get_is_content_editable(WebKitDOMHTMLElement* self);

WEBKIT_API gboolean
webkit_dom_html_element_get_spellcheck(WebKitDOMHTMLElement* self);

WEBKIT_API void
webkit_dom_html_element_set_spellcheck(WebKitDOMHTMLElement* self, gboolean value);

G_END_DECLS

#endif /* WebKitDOMHTMLElement_h */
